diff --git a/src/screen.c b/src/screen.c
index 33cb3cc..12ac091 100644
--- a/src/screen.c
+++ b/src/screen.c
@@ -1839,383 +1946,423 @@ addScreen (CompDisplay *display,
     XFreePixmap (dpy, bitmap);
     XFreeColors (dpy, s->colormap, &black.pixel, 1, 0);
 
-    glXGetConfig (dpy, visinfo, GLX_USE_GL, &value);
-    if (!value)
-    {
-	compLogMessage ("core", CompLogLevelFatal,
-			"Root visual is not a GL visual");
-	XFree (visinfo);
-	return FALSE;
-    }
-
-    glXGetConfig (dpy, visinfo, GLX_DOUBLEBUFFER, &value);
-    if (!value)
+    if (s->root.redirectSubwindows)
     {
-	compLogMessage ("core", CompLogLevelFatal,
-			"Root visual is not a double buffered GL visual");
-	XFree (visinfo);
-	return FALSE;
-    }
+	glXGetConfig (dpy, visinfo, GLX_USE_GL, &value);
+	if (!value)
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "Root visual is not a GL visual");
+	    XFree (visinfo);
+	    return FALSE;
+	}
 
-    s->ctx = glXCreateContext (dpy, visinfo, NULL, !indirectRendering);
-    if (!s->ctx)
-    {
-	compLogMessage ("core", CompLogLevelFatal, "glXCreateContext failed");
-	XFree (visinfo);
+	glXGetConfig (dpy, visinfo, GLX_DOUBLEBUFFER, &value);
+	if (!value)
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "Root visual is not a double buffered GL visual");
+	    XFree (visinfo);
+	    return FALSE;
+	}
 
-	return FALSE;
-    }
+	s->ctx = glXCreateContext (dpy, visinfo, NULL, !indirectRendering);
+	if (!s->ctx)
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "glXCreateContext failed");
+	    XFree (visinfo);
 
-    glxExtensions = glXQueryExtensionsString (dpy, screenNum);
-    if (!strstr (glxExtensions, "GLX_EXT_texture_from_pixmap"))
-    {
-	compLogMessage ("core", CompLogLevelFatal,
-			"GLX_EXT_texture_from_pixmap is missing");
-	XFree (visinfo);
+	    return FALSE;
+	}
 
-	return FALSE;
-    }
+	glxExtensions = glXQueryExtensionsString (dpy, screenNum);
+	if (!strstr (glxExtensions, "GLX_EXT_texture_from_pixmap"))
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "GLX_EXT_texture_from_pixmap is missing");
+	    XFree (visinfo);
 
-    XFree (visinfo);
+	    return FALSE;
+	}
 
-    if (!strstr (glxExtensions, "GLX_SGIX_fbconfig"))
-    {
-	compLogMessage ("core", CompLogLevelFatal,
-			"GLX_SGIX_fbconfig is missing");
-	return FALSE;
-    }
+	XFree (visinfo);
 
-    s->getProcAddress = (GLXGetProcAddressProc)
-	getProcAddress (s, "glXGetProcAddressARB");
-    s->bindTexImage = (GLXBindTexImageProc)
-	getProcAddress (s, "glXBindTexImageEXT");
-    s->releaseTexImage = (GLXReleaseTexImageProc)
-	getProcAddress (s, "glXReleaseTexImageEXT");
-    s->queryDrawable = (GLXQueryDrawableProc)
-	getProcAddress (s, "glXQueryDrawable");
-    s->getFBConfigs = (GLXGetFBConfigsProc)
-	getProcAddress (s, "glXGetFBConfigs");
-    s->getFBConfigAttrib = (GLXGetFBConfigAttribProc)
-	getProcAddress (s, "glXGetFBConfigAttrib");
-    s->createPixmap = (GLXCreatePixmapProc)
-	getProcAddress (s, "glXCreatePixmap");
-
-    if (!s->bindTexImage)
-    {
-	compLogMessage ("core", CompLogLevelFatal,
-			"glXBindTexImageEXT is missing");
-	return FALSE;
-    }
+	if (!strstr (glxExtensions, "GLX_SGIX_fbconfig"))
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "GLX_SGIX_fbconfig is missing");
+	    return FALSE;
+	}
 
-    if (!s->releaseTexImage)
-    {
-	compLogMessage ("core", CompLogLevelFatal,
-			"glXReleaseTexImageEXT is missing");
-	return FALSE;
-    }
+	s->getProcAddress = (GLXGetProcAddressProc)
+	    getProcAddress (s, "glXGetProcAddressARB");
+	s->bindTexImage = (GLXBindTexImageProc)
+	    getProcAddress (s, "glXBindTexImageEXT");
+	s->releaseTexImage = (GLXReleaseTexImageProc)
+	    getProcAddress (s, "glXReleaseTexImageEXT");
+	s->queryDrawable = (GLXQueryDrawableProc)
+	    getProcAddress (s, "glXQueryDrawable");
+	s->getFBConfigs = (GLXGetFBConfigsProc)
+	    getProcAddress (s, "glXGetFBConfigs");
+	s->getFBConfigAttrib = (GLXGetFBConfigAttribProc)
+	    getProcAddress (s, "glXGetFBConfigAttrib");
+	s->createPixmap = (GLXCreatePixmapProc)
+	    getProcAddress (s, "glXCreatePixmap");
+
+	if (!s->bindTexImage)
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "glXBindTexImageEXT is missing");
+	    return FALSE;
+	}
 
-    if (!s->queryDrawable     ||
-	!s->getFBConfigs      ||
-	!s->getFBConfigAttrib ||
-	!s->createPixmap)
-    {
-	compLogMessage ("core", CompLogLevelFatal,
-			"fbconfig functions missing");
-	return FALSE;
-    }
+	if (!s->releaseTexImage)
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "glXReleaseTexImageEXT is missing");
+	    return FALSE;
+	}
 
-    s->copySubBuffer = NULL;
-    if (strstr (glxExtensions, "GLX_MESA_copy_sub_buffer"))
-	s->copySubBuffer = (GLXCopySubBufferProc)
-	    getProcAddress (s, "glXCopySubBufferMESA");
+	if (!s->queryDrawable     ||
+	    !s->getFBConfigs      ||
+	    !s->getFBConfigAttrib ||
+	    !s->createPixmap)
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "fbconfig functions missing");
+	    return FALSE;
+	}
 
-    s->getVideoSync = NULL;
-    s->waitVideoSync = NULL;
-    if (strstr (glxExtensions, "GLX_SGI_video_sync"))
-    {
-	s->getVideoSync = (GLXGetVideoSyncProc)
-	    getProcAddress (s, "glXGetVideoSyncSGI");
+	s->copySubBuffer = NULL;
+	if (strstr (glxExtensions, "GLX_MESA_copy_sub_buffer"))
+	    s->copySubBuffer = (GLXCopySubBufferProc)
+		getProcAddress (s, "glXCopySubBufferMESA");
 
-	s->waitVideoSync = (GLXWaitVideoSyncProc)
-	    getProcAddress (s, "glXWaitVideoSyncSGI");
-    }
+	s->getVideoSync = NULL;
+	s->waitVideoSync = NULL;
+	if (strstr (glxExtensions, "GLX_SGI_video_sync"))
+	{
+	    s->getVideoSync = (GLXGetVideoSyncProc)
+		getProcAddress (s, "glXGetVideoSyncSGI");
 
-    glXMakeCurrent (dpy, s->output, s->ctx);
-    currentRoot = s->root;
+	    s->waitVideoSync = (GLXWaitVideoSyncProc)
+		getProcAddress (s, "glXWaitVideoSyncSGI");
+	}
 
-    glExtensions = (const char *) glGetString (GL_EXTENSIONS);
-    if (!glExtensions)
-    {
-	compLogMessage ("core", CompLogLevelFatal,
-			"No valid GL extensions string found.");
-	return FALSE;
-    }
+	glXMakeCurrent (dpy, s->output, s->ctx);
+	currentRoot = s->root.id;
 
-    s->textureNonPowerOfTwo = 0;
-    if (strstr (glExtensions, "GL_ARB_texture_non_power_of_two"))
-	s->textureNonPowerOfTwo = 1;
+	glExtensions = (const char *) glGetString (GL_EXTENSIONS);
+	if (!glExtensions)
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "No valid GL extensions string found.");
+	    return FALSE;
+	}
 
-    glGetIntegerv (GL_MAX_TEXTURE_SIZE, &s->maxTextureSize);
+	s->textureNonPowerOfTwo = 0;
+	if (strstr (glExtensions, "GL_ARB_texture_non_power_of_two"))
+	    s->textureNonPowerOfTwo = 1;
 
-    s->textureRectangle = 0;
-    if (strstr (glExtensions, "GL_NV_texture_rectangle")  ||
-	strstr (glExtensions, "GL_EXT_texture_rectangle") ||
-	strstr (glExtensions, "GL_ARB_texture_rectangle"))
-    {
-	s->textureRectangle = 1;
+	glGetIntegerv (GL_MAX_TEXTURE_SIZE, &s->maxTextureSize);
 
-	if (!s->textureNonPowerOfTwo)
+	s->textureRectangle = 0;
+	if (strstr (glExtensions, "GL_NV_texture_rectangle")  ||
+	    strstr (glExtensions, "GL_EXT_texture_rectangle") ||
+	    strstr (glExtensions, "GL_ARB_texture_rectangle"))
 	{
-	    GLint maxTextureSize;
+	    s->textureRectangle = 1;
 
-	    glGetIntegerv (GL_MAX_RECTANGLE_TEXTURE_SIZE_NV, &maxTextureSize);
-	    if (maxTextureSize > s->maxTextureSize)
-		s->maxTextureSize = maxTextureSize;
-	}
-    }
+	    if (!s->textureNonPowerOfTwo)
+	    {
+		GLint maxTextureSize;
 
-    if (!(s->textureRectangle || s->textureNonPowerOfTwo))
-    {
-	compLogMessage ("core", CompLogLevelFatal,
-			"Support for non power of two textures missing");
-	return FALSE;
-    }
+		glGetIntegerv (GL_MAX_RECTANGLE_TEXTURE_SIZE_NV,
+			       &maxTextureSize);
+		if (maxTextureSize > s->maxTextureSize)
+		    s->maxTextureSize = maxTextureSize;
+	    }
+	}
 
-    s->textureEnvCombine = s->textureEnvCrossbar = 0;
-    if (strstr (glExtensions, "GL_ARB_texture_env_combine"))
-    {
-	s->textureEnvCombine = 1;
+	if (!(s->textureRectangle || s->textureNonPowerOfTwo))
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "Support for non power of two textures missing");
+	    return FALSE;
+	}
 
-	/* XXX: GL_NV_texture_env_combine4 need special code but it seams to
-	   be working anyway for now... */
-	if (strstr (glExtensions, "GL_ARB_texture_env_crossbar") ||
-	    strstr (glExtensions, "GL_NV_texture_env_combine4"))
-	    s->textureEnvCrossbar = 1;
-    }
+	s->textureEnvCombine = s->textureEnvCrossbar = 0;
+	if (strstr (glExtensions, "GL_ARB_texture_env_combine"))
+	{
+	    s->textureEnvCombine = 1;
 
-    s->textureBorderClamp = 0;
-    if (strstr (glExtensions, "GL_ARB_texture_border_clamp") ||
-	strstr (glExtensions, "GL_SGIS_texture_border_clamp"))
-	s->textureBorderClamp = 1;
+	    /* XXX: GL_NV_texture_env_combine4 need special code but it
+	       seems to be working anyway for now... */
+	    if (strstr (glExtensions, "GL_ARB_texture_env_crossbar") ||
+		strstr (glExtensions, "GL_NV_texture_env_combine4"))
+		s->textureEnvCrossbar = 1;
+	}
 
-    s->maxTextureUnits = 1;
-    if (strstr (glExtensions, "GL_ARB_multitexture"))
-    {
-	s->activeTexture = (GLActiveTextureProc)
-	    getProcAddress (s, "glActiveTexture");
-	s->clientActiveTexture = (GLClientActiveTextureProc)
-	    getProcAddress (s, "glClientActiveTexture");
-	s->multiTexCoord2f = (GLMultiTexCoord2fProc)
-	    getProcAddress (s, "glMultiTexCoord2f");
-
-	if (s->activeTexture && s->clientActiveTexture && s->multiTexCoord2f)
-	    glGetIntegerv (GL_MAX_TEXTURE_UNITS_ARB, &s->maxTextureUnits);
-    }
+	s->textureBorderClamp = 0;
+	if (strstr (glExtensions, "GL_ARB_texture_border_clamp") ||
+	    strstr (glExtensions, "GL_SGIS_texture_border_clamp"))
+	    s->textureBorderClamp = 1;
 
-    s->fragmentProgram = 0;
-    if (strstr (glExtensions, "GL_ARB_fragment_program"))
-    {
-	s->genPrograms = (GLGenProgramsProc)
-	    getProcAddress (s, "glGenProgramsARB");
-	s->deletePrograms = (GLDeleteProgramsProc)
-	    getProcAddress (s, "glDeleteProgramsARB");
-	s->bindProgram = (GLBindProgramProc)
-	    getProcAddress (s, "glBindProgramARB");
-	s->programString = (GLProgramStringProc)
-	    getProcAddress (s, "glProgramStringARB");
-	s->programEnvParameter4f = (GLProgramParameter4fProc)
-	    getProcAddress (s, "glProgramEnvParameter4fARB");
-	s->programLocalParameter4f = (GLProgramParameter4fProc)
-	    getProcAddress (s, "glProgramLocalParameter4fARB");
-	s->getProgramiv = (GLGetProgramivProc)
-	    getProcAddress (s, "glGetProgramivARB");
-
-	if (s->genPrograms	       &&
-	    s->deletePrograms	       &&
-	    s->bindProgram	       &&
-	    s->programString	       &&
-	    s->programEnvParameter4f   &&
-	    s->programLocalParameter4f &&
-	    s->getProgramiv)
-	    s->fragmentProgram = 1;
-    }
+	s->maxTextureUnits = 1;
+	if (strstr (glExtensions, "GL_ARB_multitexture"))
+	{
+	    s->activeTexture = (GLActiveTextureProc)
+		getProcAddress (s, "glActiveTexture");
+	    s->clientActiveTexture = (GLClientActiveTextureProc)
+		getProcAddress (s, "glClientActiveTexture");
+	    s->multiTexCoord2f = (GLMultiTexCoord2fProc)
+		getProcAddress (s, "glMultiTexCoord2f");
+
+	    if (s->activeTexture       &&
+		s->clientActiveTexture &&
+		s->multiTexCoord2f)
+		glGetIntegerv (GL_MAX_TEXTURE_UNITS_ARB, &s->maxTextureUnits);
+	}
 
-    s->fbo = 0;
-    if (strstr (glExtensions, "GL_EXT_framebuffer_object"))
-    {
-	s->genFramebuffers = (GLGenFramebuffersProc)
-	    getProcAddress (s, "glGenFramebuffersEXT");
-	s->deleteFramebuffers = (GLDeleteFramebuffersProc)
-	    getProcAddress (s, "glDeleteFramebuffersEXT");
-	s->bindFramebuffer = (GLBindFramebufferProc)
-	    getProcAddress (s, "glBindFramebufferEXT");
-	s->checkFramebufferStatus = (GLCheckFramebufferStatusProc)
-	    getProcAddress (s, "glCheckFramebufferStatusEXT");
-	s->framebufferTexture2D = (GLFramebufferTexture2DProc)
-	    getProcAddress (s, "glFramebufferTexture2DEXT");
-	s->generateMipmap = (GLGenerateMipmapProc)
-	    getProcAddress (s, "glGenerateMipmapEXT");
-
-	if (s->genFramebuffers	      &&
-	    s->deleteFramebuffers     &&
-	    s->bindFramebuffer	      &&
-	    s->checkFramebufferStatus &&
-	    s->framebufferTexture2D   &&
-	    s->generateMipmap)
-	    s->fbo = 1;
-    }
+	s->fragmentProgram = 0;
+	if (strstr (glExtensions, "GL_ARB_fragment_program"))
+	{
+	    s->genPrograms = (GLGenProgramsProc)
+		getProcAddress (s, "glGenProgramsARB");
+	    s->deletePrograms = (GLDeleteProgramsProc)
+		getProcAddress (s, "glDeleteProgramsARB");
+	    s->bindProgram = (GLBindProgramProc)
+		getProcAddress (s, "glBindProgramARB");
+	    s->programString = (GLProgramStringProc)
+		getProcAddress (s, "glProgramStringARB");
+	    s->programEnvParameter4f = (GLProgramParameter4fProc)
+		getProcAddress (s, "glProgramEnvParameter4fARB");
+	    s->programLocalParameter4f = (GLProgramParameter4fProc)
+		getProcAddress (s, "glProgramLocalParameter4fARB");
+	    s->getProgramiv = (GLGetProgramivProc)
+		getProcAddress (s, "glGetProgramivARB");
+
+	    if (s->genPrograms	           &&
+		s->deletePrograms	   &&
+		s->bindProgram	           &&
+		s->programString	   &&
+		s->programEnvParameter4f   &&
+		s->programLocalParameter4f &&
+		s->getProgramiv)
+		s->fragmentProgram = 1;
+	}
 
-    s->textureCompression = 0;
-    if (strstr (glExtensions, "GL_ARB_texture_compression"))
-	s->textureCompression = 1;
+	s->fbo = 0;
+	if (strstr (glExtensions, "GL_EXT_framebuffer_object"))
+	{
+	    s->genFramebuffers = (GLGenFramebuffersProc)
+		getProcAddress (s, "glGenFramebuffersEXT");
+	    s->deleteFramebuffers = (GLDeleteFramebuffersProc)
+		getProcAddress (s, "glDeleteFramebuffersEXT");
+	    s->bindFramebuffer = (GLBindFramebufferProc)
+		getProcAddress (s, "glBindFramebufferEXT");
+	    s->checkFramebufferStatus = (GLCheckFramebufferStatusProc)
+		getProcAddress (s, "glCheckFramebufferStatusEXT");
+	    s->framebufferTexture2D = (GLFramebufferTexture2DProc)
+		getProcAddress (s, "glFramebufferTexture2DEXT");
+	    s->generateMipmap = (GLGenerateMipmapProc)
+		getProcAddress (s, "glGenerateMipmapEXT");
+
+	    if (s->genFramebuffers	  &&
+		s->deleteFramebuffers     &&
+		s->bindFramebuffer	  &&
+		s->checkFramebufferStatus &&
+		s->framebufferTexture2D   &&
+		s->generateMipmap)
+		s->fbo = 1;
+	}
 
-    fbConfigs = (*s->getFBConfigs) (dpy,
-				    screenNum,
-				    &nElements);
+	s->textureCompression = 0;
+	if (strstr (glExtensions, "GL_ARB_texture_compression"))
+	    s->textureCompression = 1;
 
-    for (i = 0; i <= MAX_DEPTH; i++)
-    {
-	int j, db, stencil, depth, alpha, mipmap, rgba;
+	fbConfigs = (*s->getFBConfigs) (dpy,
+					screenNum,
+					&nElements);
 
-	s->glxPixmapFBConfigs[i].fbConfig       = NULL;
-	s->glxPixmapFBConfigs[i].mipmap         = 0;
-	s->glxPixmapFBConfigs[i].yInverted      = 0;
-	s->glxPixmapFBConfigs[i].textureFormat  = 0;
-	s->glxPixmapFBConfigs[i].textureTargets = 0;
+	for (i = 0; i <= MAX_DEPTH; i++)
+	{
+	    int j, db, stencil, depth, alpha, mipmap, rgba;
 
-	db      = MAXSHORT;
-	stencil = MAXSHORT;
-	depth   = MAXSHORT;
-	mipmap  = 0;
-	rgba    = 0;
+	    s->glxPixmapFBConfigs[i].fbConfig       = NULL;
+	    s->glxPixmapFBConfigs[i].mipmap         = 0;
+	    s->glxPixmapFBConfigs[i].yInverted      = 0;
+	    s->glxPixmapFBConfigs[i].textureFormat  = 0;
+	    s->glxPixmapFBConfigs[i].textureTargets = 0;
 
-	for (j = 0; j < nElements; j++)
-	{
-	    XVisualInfo *vi;
-	    int		visualDepth;
+	    db      = MAXSHORT;
+	    stencil = MAXSHORT;
+	    depth   = MAXSHORT;
+	    mipmap  = 0;
+	    rgba    = 0;
 
-	    vi = glXGetVisualFromFBConfig (dpy, fbConfigs[j]);
-	    if (vi == NULL)
-		continue;
+	    for (j = 0; j < nElements; j++)
+	    {
+		XVisualInfo *vi;
+		int		visualDepth;
 
-	    visualDepth = vi->depth;
+		vi = glXGetVisualFromFBConfig (dpy, fbConfigs[j]);
+		if (vi == NULL)
+		    continue;
 
-	    XFree (vi);
+		visualDepth = vi->depth;
 
-	    if (visualDepth != i)
-		continue;
+		XFree (vi);
 
-	    (*s->getFBConfigAttrib) (dpy,
-				     fbConfigs[j],
-				     GLX_ALPHA_SIZE,
-				     &alpha);
-	    (*s->getFBConfigAttrib) (dpy,
-				     fbConfigs[j],
-				     GLX_BUFFER_SIZE,
-				     &value);
-	    if (value != i && (value - alpha) != i)
-		continue;
+		if (visualDepth != i)
+		    continue;
 
-	    value = 0;
-	    if (i == 32)
-	    {
 		(*s->getFBConfigAttrib) (dpy,
 					 fbConfigs[j],
-					 GLX_BIND_TO_TEXTURE_RGBA_EXT,
+					 GLX_ALPHA_SIZE,
+					 &alpha);
+		(*s->getFBConfigAttrib) (dpy,
+					 fbConfigs[j],
+					 GLX_BUFFER_SIZE,
 					 &value);
+		if (value != i && (value - alpha) != i)
+		    continue;
+
+		value = 0;
+		if (i == 32)
+		{
+		    (*s->getFBConfigAttrib) (dpy,
+					     fbConfigs[j],
+					     GLX_BIND_TO_TEXTURE_RGBA_EXT,
+					     &value);
+
+		    if (value)
+		    {
+			rgba = 1;
+
+			s->glxPixmapFBConfigs[i].textureFormat =
+			    GLX_TEXTURE_FORMAT_RGBA_EXT;
+		    }
+		}
 
-		if (value)
+		if (!value)
 		{
-		    rgba = 1;
+		    if (rgba)
+			continue;
+
+		    (*s->getFBConfigAttrib) (dpy,
+					     fbConfigs[j],
+					     GLX_BIND_TO_TEXTURE_RGB_EXT,
+					     &value);
+		    if (!value)
+			continue;
 
 		    s->glxPixmapFBConfigs[i].textureFormat =
-			GLX_TEXTURE_FORMAT_RGBA_EXT;
+			GLX_TEXTURE_FORMAT_RGB_EXT;
 		}
-	    }
 
-	    if (!value)
-	    {
-		if (rgba)
+		(*s->getFBConfigAttrib) (dpy,
+					 fbConfigs[j],
+					 GLX_DOUBLEBUFFER,
+					 &value);
+		if (value > db)
 		    continue;
 
+		db = value;
+
 		(*s->getFBConfigAttrib) (dpy,
 					 fbConfigs[j],
-					 GLX_BIND_TO_TEXTURE_RGB_EXT,
+					 GLX_STENCIL_SIZE,
 					 &value);
-		if (!value)
+		if (value > stencil)
 		    continue;
 
-		s->glxPixmapFBConfigs[i].textureFormat =
-		    GLX_TEXTURE_FORMAT_RGB_EXT;
-	    }
-
-	    (*s->getFBConfigAttrib) (dpy,
-				     fbConfigs[j],
-				     GLX_DOUBLEBUFFER,
-				     &value);
-	    if (value > db)
-		continue;
+		stencil = value;
 
-	    db = value;
+		(*s->getFBConfigAttrib) (dpy,
+					 fbConfigs[j],
+					 GLX_DEPTH_SIZE,
+					 &value);
+		if (value > depth)
+		    continue;
 
-	    (*s->getFBConfigAttrib) (dpy,
-				     fbConfigs[j],
-				     GLX_STENCIL_SIZE,
-				     &value);
-	    if (value > stencil)
-		continue;
+		depth = value;
 
-	    stencil = value;
+		if (s->fbo)
+		{
+		    (*s->getFBConfigAttrib) (dpy,
+					     fbConfigs[j],
+					     GLX_BIND_TO_MIPMAP_TEXTURE_EXT,
+					     &value);
+		    if (value < mipmap)
+			continue;
+
+		    mipmap = value;
+		}
 
-	    (*s->getFBConfigAttrib) (dpy,
-				     fbConfigs[j],
-				     GLX_DEPTH_SIZE,
-				     &value);
-	    if (value > depth)
-		continue;
+		(*s->getFBConfigAttrib) (dpy,
+					 fbConfigs[j],
+					 GLX_Y_INVERTED_EXT,
+					 &value);
 
-	    depth = value;
+		s->glxPixmapFBConfigs[i].yInverted = value;
 
-	    if (s->fbo)
-	    {
 		(*s->getFBConfigAttrib) (dpy,
 					 fbConfigs[j],
-					 GLX_BIND_TO_MIPMAP_TEXTURE_EXT,
+					 GLX_BIND_TO_TEXTURE_TARGETS_EXT,
 					 &value);
-		if (value < mipmap)
-		    continue;
 
-		mipmap = value;
+		s->glxPixmapFBConfigs[i].textureTargets = value;
+
+		s->glxPixmapFBConfigs[i].fbConfig = fbConfigs[j];
+		s->glxPixmapFBConfigs[i].mipmap   = mipmap;
 	    }
+	}
 
-	    (*s->getFBConfigAttrib) (dpy,
-				     fbConfigs[j],
-				     GLX_Y_INVERTED_EXT,
-				     &value);
+	if (nElements)
+	    XFree (fbConfigs);
 
-	    s->glxPixmapFBConfigs[i].yInverted = value;
+	if (!s->glxPixmapFBConfigs[defaultDepth].fbConfig)
+	{
+	    compLogMessage ("core", CompLogLevelFatal,
+			    "No GLXFBConfig for default depth, "
+			    "this isn't going to work.");
+	    return FALSE;
+	}
 
-	    (*s->getFBConfigAttrib) (dpy,
-				     fbConfigs[j],
-				     GLX_BIND_TO_TEXTURE_TARGETS_EXT,
-				     &value);
+	glClearColor (0.0, 0.0, 0.0, 1.0);
+	glBlendFunc (GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
+	glEnable (GL_CULL_FACE);
+	glDisable (GL_BLEND);
+	glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
+	glColor4usv (defaultColor);
+	glEnableClientState (GL_VERTEX_ARRAY);
+	glEnableClientState (GL_TEXTURE_COORD_ARRAY);
+
+	s->canDoSaturated = s->canDoSlightlySaturated = FALSE;
+	if (s->textureEnvCombine && s->maxTextureUnits >= 2)
+	{
+	    s->canDoSaturated = TRUE;
+	    if (s->textureEnvCrossbar && s->maxTextureUnits >= 4)
+		s->canDoSlightlySaturated = TRUE;
+	}
 
-	    s->glxPixmapFBConfigs[i].textureTargets = value;
+	glLightModelfv (GL_LIGHT_MODEL_AMBIENT, globalAmbient);
 
-	    s->glxPixmapFBConfigs[i].fbConfig = fbConfigs[j];
-	    s->glxPixmapFBConfigs[i].mipmap   = mipmap;
-	}
-    }
+	glEnable (GL_LIGHT0);
+	glLightfv (GL_LIGHT0, GL_AMBIENT, ambientLight);
+	glLightfv (GL_LIGHT0, GL_DIFFUSE, diffuseLight);
+	glLightfv (GL_LIGHT0, GL_POSITION, light0Position);
 
-    if (nElements)
-	XFree (fbConfigs);
+	glColorMaterial (GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
 
-    if (!s->glxPixmapFBConfigs[defaultDepth].fbConfig)
+	glNormal3f (0.0f, 0.0f, -1.0f);
+    }
+    else
     {
-	compLogMessage ("core", CompLogLevelFatal,
-			"No GLXFBConfig for default depth, "
-			"this isn't going to work.");
-	return FALSE;
+	s->maxTextureSize = SHRT_MAX;
+	s->canDoSaturated = s->canDoSlightlySaturated = FALSE;
     }
 
     initTexture (s, &s->backgroundTexture);
@@ -2223,80 +2370,13 @@ addScreen (CompDisplay *display,
 
     s->defaultIcon = NULL;
 
-    s->desktopWindowCount = 0;
-
-    glClearColor (0.0, 0.0, 0.0, 1.0);
-    glBlendFunc (GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
-    glEnable (GL_CULL_FACE);
-    glDisable (GL_BLEND);
-    glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
-    glColor4usv (defaultColor);
-    glEnableClientState (GL_VERTEX_ARRAY);
-    glEnableClientState (GL_TEXTURE_COORD_ARRAY);
-
-    s->canDoSaturated = s->canDoSlightlySaturated = FALSE;
-    if (s->textureEnvCombine && s->maxTextureUnits >= 2)
-    {
-	s->canDoSaturated = TRUE;
-	if (s->textureEnvCrossbar && s->maxTextureUnits >= 4)
-	    s->canDoSlightlySaturated = TRUE;
-    }
-
     s->redrawTime = 1000 / defaultRefreshRate;
     s->optimalRedrawTime = s->redrawTime;
 
-    reshape (s, s->attrib.width, s->attrib.height);
-
-    detectRefreshRateOfScreen (s);
-    detectOutputDevices (s);
-    updateOutputDevices (s);
-
-    glLightModelfv (GL_LIGHT_MODEL_AMBIENT, globalAmbient);
-
-    glEnable (GL_LIGHT0);
-    glLightfv (GL_LIGHT0, GL_AMBIENT, ambientLight);
-    glLightfv (GL_LIGHT0, GL_DIFFUSE, diffuseLight);
-    glLightfv (GL_LIGHT0, GL_POSITION, light0Position);
-
-    glColorMaterial (GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
-
-    glNormal3f (0.0f, 0.0f, -1.0f);
-
-    s->lighting	      = FALSE;
-    s->slowAnimations = FALSE;
-
-    addScreenToDisplay (display, s);
-
-    getDesktopHints (s);
-
-    /* TODO: bailout properly when objectInitPlugins fails */
-    assert (objectInitPlugins (&s->base));
-
-    (*core.objectAdd) (&display->base, &s->base);
-
-    XQueryTree (dpy, s->root,
-		&rootReturn, &parentReturn,
-		&children, &nchildren);
-
-    for (i = 0; i < nchildren; i++)
-	addWindow (s, children[i], i ? children[i - 1] : 0);
-
-    for (w = s->windows; w; w = w->next)
-    {
-	if (w->attrib.map_state == IsViewable)
-	{
-	    w->activeNum = s->activeNum++;
-	    w->damaged   = TRUE;
-	    w->invisible = WINDOW_INVISIBLE (w);
-	}
-    }
-
-    XFree (children);
-
     attrib.override_redirect = 1;
     attrib.event_mask	     = PropertyChangeMask;
 
-    s->grabWindow = XCreateWindow (dpy, s->root, -100, -100, 1, 1, 0,
+    s->grabWindow = XCreateWindow (dpy, s->root.id, -100, -100, 1, 1, 0,
 				   CopyFromParent, InputOnly, CopyFromParent,
 				   CWOverrideRedirect | CWEventMask,
 				   &attrib);
@@ -2306,9 +2386,13 @@ addScreen (CompDisplay *display,
     {
 	long xdndVersion = 3;
 
-	s->screenEdge[i].id = XCreateWindow (dpy, s->root, -100, -100, 1, 1, 0,
-					     CopyFromParent, InputOnly,
-					     CopyFromParent, CWOverrideRedirect,
+	s->screenEdge[i].id = XCreateWindow (dpy,
+					     s->root.id,
+					     -100, -100, 1, 1, 0,
+					     CopyFromParent,
+					     InputOnly,
+					     CopyFromParent,
+					     CWOverrideRedirect,
 					     &attrib);
 
 	XChangeProperty (dpy, s->screenEdge[i].id, display->xdndAwareAtom,
@@ -2325,19 +2409,90 @@ addScreen (CompDisplay *display,
 
     updateScreenEdges (s);
 
-    setDesktopHints (s);
-    setSupportingWmCheck (s);
-    setSupported (s);
+    reshape (s, s->attrib.width, s->attrib.height);
+
+    detectRefreshRateOfScreen (s);
+    detectOutputDevices (s);
+    updateOutputDevices (s);
+
+    s->lighting	      = FALSE;
+    s->slowAnimations = FALSE;
+
+    addScreenToDisplay (display, s);
+
+    getDesktopHints (s);
 
     s->normalCursor = XCreateFontCursor (dpy, XC_left_ptr);
     s->busyCursor   = XCreateFontCursor (dpy, XC_watch);
 
-    XDefineCursor (dpy, s->root, s->normalCursor);
+    if (s->root.substructureRedirect)
+    {
+	setDesktopHints (s);
+	setSupportingWmCheck (s);
+	setSupported (s);
+
+	XDefineCursor (dpy, s->root.id, s->normalCursor);
+    }
+    else
+    {
+	getSupportingWmCheck (&s->root);
+    }
 
     s->filter[NOTHING_TRANS_FILTER] = COMP_TEXTURE_FILTER_FAST;
     s->filter[SCREEN_TRANS_FILTER]  = COMP_TEXTURE_FILTER_GOOD;
     s->filter[WINDOW_TRANS_FILTER]  = COMP_TEXTURE_FILTER_GOOD;
 
+    /* TODO: bailout properly when objectInitPlugins fails */
+    assert (objectInitPlugins (&s->base));
+    (*core.objectAdd) (&display->base, &s->base);
+
+    assert (objectInitPlugins (&s->root.base));
+    (*core.objectAdd) (&s->base, &s->root.base);
+
+    XQueryTree (dpy, s->root.id,
+		&rootReturn, &parentReturn,
+		&children, &nchildren);
+
+    if (windowManagement)
+    {
+	XSelectInput (dpy, s->root.id,
+		      SubstructureRedirectMask |
+		      SubstructureNotifyMask   |
+		      StructureNotifyMask      |
+		      PropertyChangeMask       |
+		      LeaveWindowMask          |
+		      EnterWindowMask          |
+		      KeyPressMask             |
+		      KeyReleaseMask           |
+		      ButtonPressMask          |
+		      ButtonReleaseMask        |
+		      FocusChangeMask          |
+		      ExposureMask);
+    }
+    else
+    {
+	XSelectInput (dpy, s->root.id,
+		      SubstructureNotifyMask |
+		      StructureNotifyMask    |
+		      PropertyChangeMask     |
+		      ExposureMask);
+    }
+
+    for (i = 0; i < nchildren; i++)
+	addWindow (&s->root, children[i], i ? children[i - 1] : 0);
+
+    for (w = s->root.windows; w; w = w->next)
+    {
+	if (w->attrib.map_state == IsViewable)
+	{
+	    w->activeNum = s->activeNum++;
+	    w->damaged   = TRUE;
+	    w->invisible = WINDOW_INVISIBLE (w);
+	}
+    }
+
+    XFree (children);
+
     return TRUE;
 }
 
@@ -2357,14 +2512,14 @@ removeScreen (CompScreen *s)
     else
 	d->screens = NULL;
 
-    while (s->windows)
-	removeWindow (s->windows);
+    while (s->root.windows)
+	removeWindow (s->root.windows);
 
     (*core.objectRemove) (&d->base, &s->base);
 
     objectFiniPlugins (&s->base);
 
-    XUngrabKey (d->display, AnyKey, AnyModifier, s->root);
+    XUngrabKey (d->display, AnyKey, AnyModifier, s->root.id);
 
     for (i = 0; i < SCREEN_EDGE_NUM; i++)
 	XDestroyWindow (d->display, s->screenEdge[i].id);
@@ -2379,13 +2534,14 @@ removeScreen (CompScreen *s)
 	free (s->defaultIcon);
     }
 
-    glXDestroyContext (d->display, s->ctx);
+    if (manualCompositeManagement)
+	glXDestroyContext (d->display, s->ctx);
 
     XFreeCursor (d->display, s->invisibleCursor);
 
 #ifdef USE_COW
-    if (useCow)
-	XCompositeReleaseOverlayWindow (s->display->display, s->root);
+    if (useCow && manualCompositeManagement)
+	XCompositeReleaseOverlayWindow (s->display->display, s->root.id);
 #endif
 
     freeScreen (s);
@@ -2430,7 +2586,7 @@ forEachWindowOnScreen (CompScreen	 *screen,
 {
     CompWindow *w;
 
-    for (w = screen->windows; w; w = w->next)
+    for (w = screen->root.windows; w; w = w->next)
 	(*proc) (w, closure);
 }
 
@@ -2441,6 +2597,9 @@ focusDefaultWindow (CompScreen *s)
     CompWindow  *w;
     CompWindow  *focus = NULL;
 
+    if (!s->root.substructureRedirect)
+	return;
+
     if (!d->opt[COMP_DISPLAY_OPTION_CLICK_TO_FOCUS].value.b)
     {
 	w = findTopLevelWindowAtDisplay (d, d->below);
@@ -2461,11 +2620,11 @@ focusDefaultWindow (CompScreen *s)
 	    /* huh, we didn't find d->below ... perhaps it's out of date;
 	       try grabbing it through the server */
 
-	    status = XQueryPointer (d->display, s->root, &rootReturn,
+	    status = XQueryPointer (d->display, s->root.id, &rootReturn,
 				    &childReturn, &dummyInt, &dummyInt,
 				    &dummyInt, &dummyInt, &dummyUInt);
 
-	    if (status && rootReturn == s->root)
+	    if (status && rootReturn == s->root.id)
 	    {
 		w = findTopLevelWindowAtDisplay (d, childReturn);
 
@@ -2481,7 +2640,7 @@ focusDefaultWindow (CompScreen *s)
 
     if (!focus)
     {
-	for (w = s->reverseWindows; w; w = w->prev)
+	for (w = s->root.reverseWindows; w; w = w->prev)
 	{
 	    if (w->type & CompWindowTypeDockMask)
 		continue;
@@ -2511,7 +2670,7 @@ focusDefaultWindow (CompScreen *s)
     }
     else
     {
-	XSetInputFocus (d->display, s->root, RevertToPointerRoot,
+	XSetInputFocus (d->display, s->root.id, RevertToPointerRoot,
 			CurrentTime);
     }
 }
@@ -2528,17 +2687,17 @@ findWindowAtScreen (CompScreen *s,
     {
 	CompWindow *w;
 
-	for (w = s->windows; w; w = w->next)
+	for (w = &s->root; w; w = walkDepthFirst (w))
 	    if (w->id == id)
 		return (lastFoundWindow = w);
     }
 
-    return 0;
+    return NULL;
 }
 
 CompWindow *
-findTopLevelWindowAtScreen (CompScreen *s,
-			    Window     id)
+findClientWindowAtScreen (CompScreen *s,
+			  Window     id)
 {
     CompWindow *w;
 
@@ -2548,120 +2707,29 @@ findTopLevelWindowAtScreen (CompScreen *s,
 
     if (w->attrib.override_redirect)
     {
-	/* likely a frame window */
-	if (w->attrib.class == InputOnly)
-	{
-	    for (w = s->windows; w; w = w->next)
-		if (w->frame == id)
-		    return w;
-	}
+	if (!w->parent || w->attrib.class != InputOnly)
+	    return NULL;
 
-	return NULL;
+	/* likely a frame window */
+	for (w = w->parent->windows; w; w = w->next)
+	    if (w->frame == id)
+		break;
     }
 
     return w;
 }
 
-void
-insertWindowIntoScreen (CompScreen *s,
-			CompWindow *w,
-			Window	   aboveId)
-{
-    CompWindow *p;
-
-    if (s->windows)
-    {
-	if (!aboveId)
-	{
-	    w->next = s->windows;
-	    w->prev = NULL;
-	    s->windows->prev = w;
-	    s->windows = w;
-	}
-	else
-	{
-	    for (p = s->windows; p; p = p->next)
-	    {
-		if (p->id == aboveId)
-		{
-		    if (p->next)
-		    {
-			w->next = p->next;
-			w->prev = p;
-			p->next->prev = w;
-			p->next = w;
-		    }
-		    else
-		    {
-			p->next = w;
-			w->next = NULL;
-			w->prev = p;
-			s->reverseWindows = w;
-		    }
-		    break;
-		}
-	    }
-
-#ifdef DEBUG
-	    if (!p)
-		abort ();
-#endif
-
-	}
-    }
-    else
-    {
-	s->reverseWindows = s->windows = w;
-	w->prev = w->next = NULL;
-    }
-}
-
-void
-unhookWindowFromScreen (CompScreen *s,
-			CompWindow *w)
+CompWindow *
+findTopLevelWindowAtScreen (CompScreen *s,
+			    Window     id)
 {
-    CompWindow *next, *prev;
-
-    next = w->next;
-    prev = w->prev;
+    CompWindow *w;
 
-    if (next || prev)
-    {
-	if (next)
-	{
-	    if (prev)
-	    {
-		next->prev = prev;
-	    }
-	    else
-	    {
-		s->windows = next;
-		next->prev = NULL;
-	    }
-	}
+    w = findClientWindowAtScreen (s, id);
+    if (w && w->managed)
+	return w;
 
-	if (prev)
-	{
-	    if (next)
-	    {
-		prev->next = next;
-	    }
-	    else
-	    {
-		s->reverseWindows = prev;
-		prev->next = NULL;
-	    }
-	}
-    }
-    else
-    {
-	s->windows = s->reverseWindows = NULL;
-    }
-
-    if (w == lastFoundWindow)
-	lastFoundWindow = NULL;
-    if (w == lastDamagedWindow)
-	lastDamagedWindow = NULL;
+    return NULL;
 }
 
 #define POINTER_GRAB_MASK (ButtonReleaseMask | \
